=== examples/avsr/data_prep/requirements.txt ===
tqdm
scikit-image
opencv-python
ffmpeg-python
