=== debian/changelog ===
pytorch-audio (2.6.0-1) unstable; urgency=medium

  * Team upload.
  * New upstream version 2.6.0 (closes: #1071137)
  * d/patches:
    + refresh patches to use sox and ffmpeg from system
    + update metadata for buildsystem-fixups.patch
    + add patch to make build reproducible (closes: #1036522)
  * d/{control,rules}:
    + bump std-ver to 4.7.0 (no changes required)
    + update B-D version and replace obsolete pkg-config with pkgconf
    + build only for default Python (required by pytorch, now 3.13)
    + explicitly disable ffmpeg plugin due to lack of upstream support
  * d/copyright: remove superfluous or unused content, update some file paths
  * Generate correct dependency on pytorch variants (closes: #1077500)

 -- Shengqi Chen <harry@debian.org>  Mon, 03 Mar 2025 20:40:11 +0800
