=== debian/control ===
Source: pytorch-audio
Section: science
Homepage: https://github.com/pytorch/audio
Priority: optional
Standards-Version: 4.7.0
Vcs-Git: https://salsa.debian.org/deeplearning-team/pytorch-audio.git
Vcs-Browser: https://salsa.debian.org/deeplearning-team/pytorch-audio
Maintainer: Debian Deep Learning Team <debian-ai@lists.debian.org>
Uploaders: Mo Zhou <lumin@debian.org>
Build-Depends: debhelper-compat (= 13),
               cmake,
               dh-python,
#               libavdevice-dev,
#               libavcodec-dev,
#               libavfilter-dev,
#               libavformat-dev,
               libgflags-dev,
               libgoogle-glog-dev,
               libsox-dev,
               libtorch-dev (>= 2.6.0~),
               ninja-build,
               pkgconf,
               pybind11-dev,
               python3,
               python3-dev,
               python3-parameterized <!nocheck>,
               python3-pytest <!nocheck>,
               python3-scipy <!nocheck>,
               python3-setuptools,
               python3-torch (>= 2.6.0~),

Package: python3-torchaudio
Architecture: any
Depends: ${misc:Depends}, ${python3:Depends}, ${shlibs:Depends}
Description: Data manipulation and transformation for audio signal processing
 The aim of torchaudio is to apply PyTorch to the audio domain. By supporting
 PyTorch, torchaudio follows the same philosophy of providing strong GPU
 acceleration, having a focus on trainable features through the autograd system,
 and having consistent style (tensor names and dimension names). Therefore, it
 is primarily a machine learning library and not a general signal processing
 library. The benefits of Pytorch is be seen in torchaudio through having all
 the computations be through Pytorch operations which makes it easy to use and
 feel like a natural extension.
