=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%pytorch-audio-$1.tar.gz%" \
https://github.com/pytorch/audio/tags \
(?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian uupdate
